
%define srcname	openoffice.org
%define ooname	%srcname
%define unopkg	%{_libdir}/%{ooodir}/program/unopkg
%define binpkg	%nil
%define ooo_version %(rpm -q --qf '%%{version}' %{ooname}-devel 2>/dev/null)
%define ooo_shortver %(echo %ooo_version | perl -p -e 's/^([^\\\.]+\\\.[^\\\.]+)\\\..*/\\\1/')
%define ooodir	ooo-%{ooo_shortver}

# This is a hack, but we have to follow openoffice.org.spec naming
%ifarch x86_64
%define ooname %{srcname}64
%define ooodir	ooo-%{ooo_shortver}_64
%define binpkg -n %{binname}
%endif

%define binname	%{ooname}-voikko
%define name	%{srcname}-voikko

%define version	2.1
%define rel	1

%define unopkgname	voikko.oxt

%define ooo_version	%(rpm -q --qf '%%{version}' %{ooname}-devel 2>/dev/null)

# NOTE: There is a duplicate package section below for openoffice.org64 naming
#       hack.

Summary:	Finnish spellchecker and hyphenator for OpenOffice.org
Name:		%name
Version:	%version
Release:	%mkrel %rel
License:	GPL
Group:		Office
URL:            http://voikko.sourceforge.net/
Source:         http://downloads.sourceforge.net/voikko/%name-%version.tar.gz
BuildRoot:	%{_tmppath}/%{name}-root
BuildRequires:	%ooname-devel
BuildRequires:	zip
BuildRequires:	voikko-devel >= 1.5
Requires:	locales-fi
# Binaries are hidden inside a zip, so automatic dependencies won't work
Requires:	%{mklibname voikko 1}
Requires:	voikko-dictionary
Requires:	%ooname = %ooo_version
Requires(pre):	%ooname = %ooo_version
Requires(post):	%ooname = %ooo_version
Requires(preun):	%ooname = %ooo_version

%description
Finnish spellchecker and hyphenator component for OpenOffice.org.

Usually Voikko is automatically activated after the installation. If
that won't happen, you can manually activate it from the Writing
Aids section of the OpenOffice.org options.

%ifarch x86_64
%package -n %binname
Summary:        Finnish spellchecker and hyphenator for OpenOffice.org
Group:		Office
Requires:       locales-fi
# Binaries are hidden inside a zip, so automatic dependencies won't work
Requires:       %{mklibname voikko 1}
Requires:       voikko-dictionary
Requires:       %ooname = %ooo_version
Requires(pre):  %ooname = %ooo_version
Requires(post): %ooname = %ooo_version
Requires(preun):        %ooname = %ooo_version

%description -n %binname
Finnish spellchecker and hyphenator component for OpenOffice.org.

Usually Voikko is automatically activated after the installation. If
that won't happen, you can manually activate it from the Writing
Aids section of the OpenOffice.org options.
%endif

%prep
%setup -q

%build
. %{_libdir}/%{ooodir}/sdk/setsdkenv_unix.sh

%make OPT_FLAGS="%optflags"

%install
rm -rf %{buildroot}

install -d -m755 %{buildroot}%{_libdir}/%{binname}
install -m644 build/%{unopkgname} %{buildroot}%{_libdir}/%{binname}

%clean
rm -rf %{buildroot}

%pre %binpkg
if ! [ -x %unopkg ]; then
	echo "ERROR: Compatible version of OpenOffice.org is not installed, aborting the"
	echo "       installation or upgrade of %{binname}!"
	exit 1
fi

# (anssi) Map of triggercity:
# Note that installation of voikko implies automatic uninstallation of old
# versions for the compatible instance of openoffice.org.
# Upgrade of openoffice.org-voikko:
# - TRIGGERUN of old version is run, but $1 = 1 and $2 = 1, thus no action is
#   taken
# - POSTTRANS of new version installs new version
# Upgrade of openoffice.org to a compatible version:
# - TRIGGERUN is run, but $1 = 1 and $2 = 1, thus no action is taken
# Upgrade of openoffice.org and openoffice.org-voikko to a compatible version:
# - TRIGGERUN of old version is run, but $1 = 1 and $2 = 1, thus no action is
#   taken
# - TRIGGERUN of old version is run again, but $1 = 1 and $2 = 1, thus no
#   action is taken
# - POSTTRANS of new version installs new version
# Upgrade of openoffice.org and openoffice.org-voikko to an incompatible
# version:
# - TRIGGERIN of old version removes old version
# - TRIGGERUN of old version is run, but $1 = 1 and $2 = 1, thus no action is
#   taken
# - openoffice.org files are replaced with new versions
# - POSTTRANS of new version installs new version
# Upgrade of openoffice.org to an incompatible version, with
# openoffice.org-voikko being removed:
# - TRIGGERIN removes voikko
# - TRIGGERUN is run, but $1 = 1 and $2 = 1, thus no action is taken
# - openoffice.org files are replaced with new versions
# Downgrade of openoffice.org-voikko:
# - TRIGGERUN of new version is run, but $1 = 1 and $2 = 1, thus no action is
#   taken
# - POSTTRANS of old version installs old version
# Removal of openoffice.org-voikko:
# - TRIGGERUN removes voikko as $1 = 0 and $2 = 1
# Removal of openoffice.org and openoffice.org-voikko
# - TRIGGERUN removes voikko as $1 = 1 and $2 = 0
# - openoffice.org files are removed
#

# Posttrans is used instead of post to allow upgrade from old
# openoffice.org-voikko with preun that would remove the new version installed
# in post, without adding triggers for that.
%posttrans %binpkg
if [ -x %unopkg ]; then
	# unopkg writes into $HOME
	TMP_HOME=$(mktemp -t -d %{binname}.XXXXXX) || exit 1
	export HOME=$TMP_HOME
	# make sure no other version is installed
	for pkg in $(%unopkg list --shared 2>/dev/null | sed -ne 's/^Name: \(oo2-voikko.*\|openoffice.org-voikko.*\|voikko.oxt\)/\1/p'); do
		%unopkg remove --shared $pkg
	done
	%unopkg add --shared %{_libdir}/%{binname}/%{unopkgname}
	rm -rf $TMP_HOME
fi

%triggerun %binpkg -- %ooname = %ooo_version
# Preun script cannot be used for this as rpm doesn't honor Requires(preun),
# but just removes OOo before preun would be run.
# Executed just before OOo or voikko is being completely removed. Does not run
# on normal upgrades.
if [ $1 -eq 0 ] || [ $2 -eq 0 ]; then
	if [ -x %unopkg ]; then
		# unopkg writes into $HOME
		TMP_HOME=$(mktemp -t -d %{binname}.XXXXXX) || exit 1
		export HOME=$TMP_HOME
		%unopkg remove --shared %{unopkgname}
		rm -rf $TMP_HOME
	fi
fi
true

%triggerin %binpkg -- %ooname > %ooo_version
# Executed just before OOo is being upgraded to an incompatible version.
# Cannot be in preun for the same reason as above triggerun.
if [ -x %unopkg ]; then
	# unopkg writes into $HOME
	TMP_HOME=$(mktemp -t -d %{binname}.XXXXXX) || exit 1
	export HOME=$TMP_HOME
	%unopkg remove --shared %{unopkgname}
	rm -rf $TMP_HOME
fi

%files %binpkg
%defattr(-,root,root)
%doc README ChangeLog
%{_libdir}/%{binname}


%changelog
* Sat Sep 01 2007 Anssi Hannula <anssi@mandriva.org> 2.1-1mdv2008.0
+ Revision: 77710
- 2.1
- remove now unneeded build flags

* Sat Jul 21 2007 Anssi Hannula <anssi@mandriva.org> 2.0.1-4mdv2008.0
+ Revision: 54356
- redefine HOME before calling unopkg as it writes there

* Wed Jul 18 2007 Anssi Hannula <anssi@mandriva.org> 2.0.1-3mdv2008.0
+ Revision: 53235
- add triggers to workaround rpm not honoring Requires(preun)
- document upgrade paths extensively in spec

* Fri Jul 06 2007 Anssi Hannula <anssi@mandriva.org> 2.0.1-2mdv2008.0
+ Revision: 49173
- rebuild for new openoffice.org

* Tue May 15 2007 Anssi Hannula <anssi@mandriva.org> 2.0.1-1mdv2008.0
+ Revision: 27050
- 2.0.1

* Mon Apr 30 2007 Anssi Hannula <anssi@mandriva.org> 2.0-2mdv2008.0
+ Revision: 19580
- fix license

* Mon Apr 30 2007 Anssi Hannula <anssi@mandriva.org> 2.0-1mdv2008.0
+ Revision: 19515
- 2.0
- ignore unopkg failure during preun


* Wed Feb 28 2007 Anssi Hannula <anssi@mandriva.org> 1.2-3mdv2007.0
+ Revision: 127331
- allow co-installation with openoffice.org(64)-go-ooo-voikko
- update package name in %%pre incompatibility error message

* Mon Feb 12 2007 Anssi Hannula <anssi@mandriva.org> 1.2-2mdv2007.1
+ Revision: 119899
- adapt .spec for building with different OOo versions
- add Requires(post) to x86_64 package too
- rebuild for new openoffice.org
- update URL

* Sat Nov 11 2006 Anssi Hannula <anssi@mandriva.org> 1.2-1mdv2007.1
+ Revision: 83154
- 1.2
- adapt spec for upstream name change
- Import openoffice.org-voikko

* Sat Sep 16 2006 Anssi Hannula <anssi@mandriva.org> 1.1-2mdv2007.0
- change ooodir to match latest openoffice.org on x86_64

* Sun Sep 03 2006 Anssi Hannula <anssi@mandriva.org> 1.1-1mdv2007.0
- 1.1 (bugfixes)

* Sat Sep 02 2006 Anssi Hannula <anssi@mandriva.org> 1.0-4mdv2007.0
- more robust update handling with posttrans

* Sat Aug 26 2006 Anssi Hannula <anssi@mnadriva.org> 1.0-3mdv2007.0
- report correct src.rpm name on x86_64
- fix no-documentation

* Thu Aug 24 2006 Anssi Hannula <anssi@mandriva.org> 1.0-2mdv2007.0
- use openoffice.org naming on x86_64

* Wed Aug 23 2006 Anssi Hannula <anssi@mandriva.org> 1.0-1mdv2007.0
- initial Mandriva release

